;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


align_proc
BubbleSort proc dummy:dword
	mov		g_bActiveProcces, true
	.for (edi=ArraySize, bl=true: bl: edi--)
		.for (esi=1, bl=false: esi < edi: esi++)	;bl:swapped
			inc		countComp
			mov		eax, Array[esi*4-1*4]
			mov		edx, Array[esi*4]
			.if (sdword ptr edx < eax)
				mov		Array[esi*4], eax
				mov		Array[esi*4-1*4], edx
				mov		bl, true
				;----------------------
				inc		countSwap
				mov		bUpdateColumns[esi], true
				mov		bUpdateColumns[esi-1], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endif
		.endfor 
	.endfor
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al;=false
	mov		g_bPause, al;=false
	ret
BubbleSort endp

align_proc
BrickSort proc uses edi ebx dummy:dword
	mov		g_bActiveProcces, true
	xor		bl, bl	;=false		//флаг Ц были/не были перестановки в проходе
	.while (!bl)
		mov		bl, true
		mov		edi, 1
		.repeat
			inc		countComp
			mov		eax, Array[edi*4]
			.if (eax>Array[edi*4+4])
				xor		bl, bl	;=false
				;swap(A[j-1], A[j])
				mov		edx, eax
				mov		eax, Array[edi*4+4]
				mov		Array[edi*4+4], edx
				mov		Array[edi*4], eax
				;----------------------
				inc		countSwap
				mov		bUpdateColumns[edi+1], true
				mov		bUpdateColumns[edi], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endif
			add		edi, 2
		.until (edi>=ArraySize-1)
		xor		edi, edi
		.repeat
			inc		countComp
			mov		eax, Array[edi*4]
			.if (eax>Array[edi*4+4])
				xor		bl, bl	;=false
				;swap(A[j-1], A[j])
				mov		edx, eax
				mov		eax, Array[edi*4+4]
				mov		Array[edi*4+4], edx
				mov		Array[edi*4], eax
				;----------------------
				inc		countSwap
				mov		bUpdateColumns[edi+1], true
				mov		bUpdateColumns[edi], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endif
			add		edi, 2
		.until (edi>=ArraySize-1)
	.endw
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
BrickSort endp

align_proc
quick_sort proc uses esi edi ebx pBegin:ptr sdword, pEnd:ptr sdword
	ASSUME	edi:ptr sdword, esi:ptr sdword
	.if (!g_bBreak)
		mov		edi, pBegin		;указатель на первый элемент массива
		mov		esi, pEnd		;указатель на последний элемент массива
		.if (edi!=esi)
			;pivot = pBegin[(pEnd - pBegin + 1)/2];//ebx
			lea		edx, [esi+1*4]
			.for (edx-=edi, edx>>=3, ebx=[edi+edx*4]: : edi+=4, esi-=4)
				.for (: sdword ptr [edi] < ebx: edi+=4)
					inc		countComp
				.endfor
				.for (: sdword ptr [esi] > ebx: esi-=4)
					inc		countComp
				.endfor
				.break .if (edi >= esi)
				swap	[edi], [esi]
				;----------------------
				inc		countSwap
				mov		eax, edi
				sub		eax, offset Array
				shr		eax, 2;/=4
				mov		bUpdateColumns[eax], true
				mov		eax, esi
				sub		eax, offset Array
				shr		eax, 2;/=4
				mov		bUpdateColumns[eax], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endfor
			quick_sort(pBegin, &[edi-1*4])
			quick_sort(edi, pEnd)
		.endif
	.endif
	ASSUME	edi:nothing, esi:nothing
EXIT:
	ret
quick_sort endp

align_proc
QuickSort proc dummy:dword
	mov		g_bActiveProcces, true
	quick_sort(&Array[0*4], &Array[ArraySize*4-4])
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
QuickSort endp

align_proc
ShakerSort proc dummy:dword
local left:dword
	mov		g_bActiveProcces, true
	mov		esi, ArraySize-1	;right
	mov		ebx, ArraySize-1	;control
	and		left, 0
	.repeat
		mov		edi, left	;i
		.repeat
			inc		countComp
			mov		edx, Array[edi*4]
			.if (edx>Array[edi*4+4])
				;swap(A[i+1], A[i])
				mov		eax, Array[edi*4+4]
				mov		Array[edi*4+4], edx
				mov		Array[edi*4], eax
				mov		ebx, edi
				;----------------------
				inc		countSwap
				mov		bUpdateColumns[edi+1], true
				mov		bUpdateColumns[edi], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endif
			inc		edi ;i--
		.until (edi>=esi)
		mov		esi, ebx
		mov		edi, ebx
		.repeat
			inc		countComp
			mov		edx, Array[edi*4]
			.if (edx<Array[edi*4-4])
				;swap(A[i-1], A[i])
				mov		eax, Array[edi*4-4]
				mov		Array[edi*4-4], edx
				mov		Array[edi*4], eax
				mov		ebx, edi
				;----------------------
				inc		countSwap
				mov		bUpdateColumns[edi-1], true
				mov		bUpdateColumns[edi], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endif
			dec		edi
		.until (edi<=left)
		mov		left, ebx
	.until (ebx>=esi)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
ShakerSort endp

align_proc
HeapSort proc uses esi edi ebx dummy:dword
	mov		g_bActiveProcces, true
	mov		esi, ArraySize/2	;Left
	mov		edi, ArraySize-1	;Right
	.repeat
		dec		esi		;Left--;
		call	shift
	.until (esi==0)
	.repeat
		swap	Array[0], Array[edi*4]
		inc		countSwap
		mov		bUpdateColumns[edi], true
		mov		bUpdateColumns[0], true
		dec		edi		;Right--
		call	shift
	.until (edi==0)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
; процедура вставки элемента на свое место в пирамиду
shift:
	mov		edx, esi			;i = Left;
	mov		ebx, Array[esi*4]	;item
	lea		ecx, [esi*2]		;j = Left*2
	.while (true)
		inc		countComp
		mov		eax, Array[ecx*4]
		.if (ecx<edi && eax<Array[ecx*4+4])
			inc		ecx			;j++
		.endif
		.break .if (ecx>edi)
		mov		eax, Array[ecx*4]
		.break .if (ebx>=eax)
		mov		Array[edx*4], eax	;array[i] = array[j];
		;----------------------
		mov		bUpdateColumns[edx], true
		inc		countSwap
		push	ecx
		Sleep(g_iDelay)
		pop		ecx
		.repeat ;//приостановить процесс сортировки
			.if (g_bBreak)
				pop		eax
				jmp		EXIT
			.endif
		.until (g_bPause==false)
		;----------------------
		mov		edx, ecx 	;i = j;
		add		ecx, ecx	;j*=2
	.endw
	mov		Array[edx*4], ebx
	mov		bUpdateColumns[edx], true
	retn
HeapSort endp

.const
align 4
Shell_table	sdword 21523351*4, 7174450*4, 2391483*4, 797161*4, 265720*4, 88573*4, 29524*4, 9841*4
			sdword     3280*4,    1093*4,     364*4,    121*4,     40*4,    13*4,     4*4,    1*4
.code

align_proc
ShellSort proc dummy:dword
local i:dword, j:dword
	mov		g_bActiveProcces, true
	mov		ecx, -17; 16 элементов в таблице приращений
	.repeat
		inc		ecx
	.until (Shell_table[ecx*4+16*4]<ArraySize); ищем максимальное приращение, соответствующее размеру нашего массива
	mov		j, ecx	;=Shell_index
	.repeat
		mov		ecx, j
		mov		edi, Shell_table[ecx*4+16*4]; элемент из таблицы соответствующий индексу
		; выбрали интервал,  у нас двойные слова, поэтому умножаем на 4
		mov		i, edi;i=gap
		.repeat
			mov		esi, i
			sub		esi, edi;j=i-gap
			.repeat
				inc		countComp
				mov		edx, Array[esi];for(i=gap;i<dim;i++)/*проход массива*/
				.break .if (edx<=Array[esi+edi]);сравнение пар, отстоящих на gap друг от друга
				mov		eax, edx
				mov		edx, Array[esi+edi];swap(a[j],a[j+gap])
				mov		Array[esi+edi], eax
				mov		Array[esi], edx
				;----------------------
				inc		countSwap
				mov		eax, edi
				shr		eax, 2;/=4
				mov		edx, esi
				shr		edx, 2;/=4
				mov		bUpdateColumns[edx+eax], true
				mov		bUpdateColumns[edx], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
				sub		esi, edi  ; j-=gap
			.until (less?)
			add		i, 4    ;i++
		.until (i>=ArraySize*4)
		inc		j
	.until (zero?)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
ShellSort endp

align_proc
SelectionSort proc uses ebx dummy:dword
	mov		g_bActiveProcces, true
	xor		edi, edi
	.repeat
		mov		ebx, edi	;min_index
		lea		esi, [edi+1]	;for (j = i + 1; j < ArraySize; j++)
		.repeat
			inc		countComp
			mov		eax, Array[esi*4]
			.if (eax<=Array[ebx*4])
				mov		ebx, esi;min_index = j
			.endif
			inc		esi
		.until (esi>=ArraySize)
		.if (ebx!=edi)
			mov		eax, Array[edi*4]
			mov		ecx, eax
			mov		eax, Array[ebx*4]
			mov		Array[ebx*4], ecx
			mov		Array[edi*4], eax
			;----------------------
			inc		countSwap
			mov		bUpdateColumns[ebx], true
			mov		bUpdateColumns[edi], true
			Sleep(g_iDelay)
			.repeat ;//приостановить процесс сортировки
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			;----------------------
		.endif
		inc		edi
	.until (edi>=ArraySize-1)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
SelectionSort endp

align_proc
GnomeSort proc dummy:dword
	mov		g_bActiveProcces, true
	mov		edi, 1
	.repeat
		.while (edi)
			inc		countComp
			mov		eax, Array[edi*4-4]
			.break .if (eax<=Array[edi*4])
			mov		edx, eax
			mov		eax, Array[edi*4]
			mov		Array[edi*4], edx
			mov     Array[edi*4-4], eax
			;----------------------
			inc		countSwap
			mov		bUpdateColumns[edi], true
			mov		bUpdateColumns[edi-1], true
			Sleep(g_iDelay)
			.repeat ;//приостановить процесс сортировки
				cmp		g_bBreak, 0
				jne		EXIT
			.until (g_bPause==false)
			;----------------------
			dec     edi
		.endw
		inc		edi
	.until (edi>=ArraySize)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
GnomeSort endp

align_proc
CombSort proc  dummy:dword
local step:real4, factor:real4
	mov		g_bActiveProcces, true
	mov		factor, 0.801711879 ;= 1.0/1.2473309;
	;step = (float)ArraySize*factor;
	mov		eax, ArraySize
	cvtsi2ss xmm0, eax
	mulss	xmm0, factor	;137/1.2473309
	movss	step, xmm0
	.while (xmm0 > CFP4(1.0))
		cvtss2si esi, xmm0
		xor		edi, edi
		.repeat
			inc		countComp
			mov		edx, Array[edi*4]
			mov		eax, Array[esi*4]
			.if (sdword ptr edx>eax)
				mov		Array[edi*4], eax
				mov		Array[esi*4], edx
				;----------------------
				inc		countSwap
				mov		bUpdateColumns[edi], true
				mov		bUpdateColumns[esi], true
				Sleep(g_iDelay)
				.repeat ;//приостановить процесс сортировки
					cmp		g_bBreak, 0
					jne		EXIT
				.until (g_bPause==false)
				;----------------------
			.endif
			inc		edi
			inc		esi
		.until (esi>=ArraySize)
		movss	xmm0, step
		mulss	xmm0, factor
		movss	step, xmm0
	.endw
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
CombSort endp

align_proc
InsertionSort proc  dummy:dword
	mov		g_bActiveProcces, true
	xor		esi, esi	;i=0
	.repeat
		mov		ebx, esi		;min=i
		lea		edi, [esi+1]	;j=i+1
		.repeat
			inc		countComp
			mov		eax, Array[edi*4]		
			cmp		Array[ebx*4], eax	;if(x[min]>x[j]) min = j
			cmova	ebx, edi
			inc		edi			;j++
		.until (edi>=ArraySize)
		swap	Array[ebx*4], Array[esi*4]	;eax, edx
		;----------------------
		inc		countSwap
		mov		bUpdateColumns[ebx], true
		mov		bUpdateColumns[esi], true
		Sleep(g_iDelay)
		.repeat ;//приостановить процесс сортировки
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		;----------------------
		inc		esi			;i++
	.until (esi>=ArraySize-1)
EXIT:
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
InsertionSort endp

static_int	temp, ArraySize dup(?)

align_proc
merge proc uses esi edi ebx iFirst:sdword, iHalf:sdword, iLast:sdword
	;int	first = iFirst, half = iHalf, cur = 0;
	.for (esi=iFirst, edi=iHalf, ebx=0: esi < iHalf && edi < iLast: ebx++)
		inc		countComp
		mov		eax, Array[esi*4]
		mov		edx, Array[edi*4]
		.if (sdword ptr eax < edx)
			mov		temp[ebx*4], eax
			inc		esi
		.else
			mov		temp[ebx*4], edx
			inc		edi
		.endif
	.endfor
	.for (:esi < iHalf :ebx++, esi++)
		mrm		temp[ebx*4], Array[esi*4]
	.endfor
	.for (:edi < iLast :ebx++, edi++)
		mrm		temp[ebx*4], Array[edi*4]
	.endfor
	.for (esi=iFirst, ebx=0: esi < iLast: esi++, ebx++)
		mrm		Array[esi*4], temp[ebx*4]
		;----------------------
		inc		countSwap
		mov		bUpdateColumns[esi], true
		Sleep(g_iDelay)
		.repeat ;//приостановить процесс сортировки
			cmp		g_bBreak, 0
			jne		EXIT
		.until (g_bPause==false)
		;----------------------
	.endfor
EXIT:
	ret
merge endp

align_proc
merge_sort proc uses esi edi ebx iFirst:sdword, iLast:sdword
	.if (!g_bBreak)
		mov		esi, iFirst
		mov		edi, iLast
		mov		eax, edi
		sub		eax, esi	;(iLast - iFirst)
		.if (sdword ptr eax > 1)
			;int iHalf = iFirst + (iLast - iFirst)/2;
			shr		eax, 1;/=2
			lea		ebx, [esi+eax]	;iHalf
			merge_sort(esi, ebx)
			merge_sort(ebx, edi)
			merge(esi, ebx, edi)
		.endif
	.endif
	ret
merge_sort endp

align_proc
MergeSort proc  dummy:dword
	mov		g_bActiveProcces, true
	merge_sort(0, ArraySize)
	xor		eax, eax
	mov		g_bActiveProcces, al ;=false
	mov		g_bPause, al  ;=false
	ret
MergeSort endp
